/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module IBinder
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.os');

/**
 * constructor
 * http://developer.android.com/reference/android/os/IBinder.html
 **/
var IBinder = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'android.os.IBinder') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('android.os.IBinder');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
IBinder.prototype = Object.create(SuperClass.prototype);
IBinder.prototype.constructor = IBinder;

Object.defineProperty(IBinder.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new IBinder(this.$native.super);
	},
	enumerable: true
});

IBinder.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

IBinder.className = "android.os.IBinder";
IBinder.prototype.className = "android.os.IBinder";

// class property
Object.defineProperty(IBinder, 'class', {
	get: function() {
		return Hyperloop.getClass('android.os.IBinder');
	},
	enumerable: true,
	configurable: false
});

// Cast
IBinder.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new IBinder(Hyperloop.cast('android.os.IBinder', object.$native));
};

// Constants
// http://developer.android.com/reference/android/os/IBinder.html#FIRST_CALL_TRANSACTION
IBinder.FIRST_CALL_TRANSACTION = 1;
// http://developer.android.com/reference/android/os/IBinder.html#PING_TRANSACTION
IBinder.PING_TRANSACTION = 1599098439;
// http://developer.android.com/reference/android/os/IBinder.html#LAST_CALL_TRANSACTION
IBinder.LAST_CALL_TRANSACTION = 16777215;
// http://developer.android.com/reference/android/os/IBinder.html#DUMP_TRANSACTION
IBinder.DUMP_TRANSACTION = 1598311760;
// http://developer.android.com/reference/android/os/IBinder.html#FLAG_ONEWAY
IBinder.FLAG_ONEWAY = 1;
// http://developer.android.com/reference/android/os/IBinder.html#TWEET_TRANSACTION
IBinder.TWEET_TRANSACTION = 1599362900;
// http://developer.android.com/reference/android/os/IBinder.html#LIKE_TRANSACTION
IBinder.LIKE_TRANSACTION = 1598835019;
// http://developer.android.com/reference/android/os/IBinder.html#INTERFACE_TRANSACTION
IBinder.INTERFACE_TRANSACTION = 1598968902;

// Static methods

// Instance methods
/**
 * @function getInterfaceDescriptor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/IBinder.html#getInterfaceDescriptor()}
 **/
IBinder.prototype.getInterfaceDescriptor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInterfaceDescriptor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.IBinder') {
			return new IBinder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function transact
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/IBinder.html#transact(int, android.os.Parcel, android.os.Parcel, int)}
 **/
IBinder.prototype.transact = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'transact',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.IBinder') {
			return new IBinder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function queryLocalInterface
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/IBinder.html#queryLocalInterface(java.lang.String)}
 **/
IBinder.prototype.queryLocalInterface = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'queryLocalInterface',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.IBinder') {
			return new IBinder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isBinderAlive
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/IBinder.html#isBinderAlive()}
 **/
IBinder.prototype.isBinderAlive = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isBinderAlive',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.IBinder') {
			return new IBinder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function dump
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/IBinder.html#dump(java.io.FileDescriptor, java.lang.String[])}
 **/
IBinder.prototype.dump = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dump',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.IBinder') {
			return new IBinder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function dumpAsync
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/IBinder.html#dumpAsync(java.io.FileDescriptor, java.lang.String[])}
 **/
IBinder.prototype.dumpAsync = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dumpAsync',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.IBinder') {
			return new IBinder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function linkToDeath
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/IBinder.html#linkToDeath(android.os.IBinder$DeathRecipient, int)}
 **/
IBinder.prototype.linkToDeath = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'linkToDeath',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.IBinder') {
			return new IBinder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function unlinkToDeath
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/IBinder.html#unlinkToDeath(android.os.IBinder$DeathRecipient, int)}
 **/
IBinder.prototype.unlinkToDeath = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unlinkToDeath',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.IBinder') {
			return new IBinder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function pingBinder
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/IBinder.html#pingBinder()}
 **/
IBinder.prototype.pingBinder = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'pingBinder',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.IBinder') {
			return new IBinder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

IBinder.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

IBinder.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = IBinder;
