/**
 * Hyperloop
 * Generated code is Copyright (c) 2019 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module InputConnection
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.inputmethod');

/**
 * constructor
 * http://developer.android.com/reference/android/view/inputmethod/InputConnection.html
 **/
var InputConnection = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'android.view.inputmethod.InputConnection') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('android.view.inputmethod.InputConnection');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
InputConnection.prototype = Object.create(SuperClass.prototype);
InputConnection.prototype.constructor = InputConnection;

Object.defineProperty(InputConnection.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new InputConnection(this.$native.super);
	},
	enumerable: true
});

InputConnection.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

InputConnection.className = "android.view.inputmethod.InputConnection";
InputConnection.prototype.className = "android.view.inputmethod.InputConnection";

// class property
Object.defineProperty(InputConnection, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.inputmethod.InputConnection');
	},
	enumerable: true,
	configurable: false
});

// Cast
InputConnection.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new InputConnection(Hyperloop.cast('android.view.inputmethod.InputConnection', object.$native));
};

// Constants
// http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#GET_EXTRACTED_TEXT_MONITOR
InputConnection.GET_EXTRACTED_TEXT_MONITOR = 1;
// http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#INPUT_CONTENT_GRANT_READ_URI_PERMISSION
InputConnection.INPUT_CONTENT_GRANT_READ_URI_PERMISSION = 1;
// http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#CURSOR_UPDATE_MONITOR
InputConnection.CURSOR_UPDATE_MONITOR = 2;
// http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#CURSOR_UPDATE_IMMEDIATE
InputConnection.CURSOR_UPDATE_IMMEDIATE = 1;
// http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#GET_TEXT_WITH_STYLES
InputConnection.GET_TEXT_WITH_STYLES = 1;

// Static methods

// Instance methods
/**
 * @function getSelectedText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#getSelectedText(int)}
 **/
InputConnection.prototype.getSelectedText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSelectedText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function commitCorrection
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#commitCorrection(android.view.inputmethod.CorrectionInfo)}
 **/
InputConnection.prototype.commitCorrection = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'commitCorrection',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function performContextMenuAction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#performContextMenuAction(int)}
 **/
InputConnection.prototype.performContextMenuAction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'performContextMenuAction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getTextAfterCursor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#getTextAfterCursor(int, int)}
 **/
InputConnection.prototype.getTextAfterCursor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTextAfterCursor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function clearMetaKeyStates
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#clearMetaKeyStates(int)}
 **/
InputConnection.prototype.clearMetaKeyStates = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'clearMetaKeyStates',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getHandler
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#getHandler()}
 **/
InputConnection.prototype.getHandler = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getHandler',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function performPrivateCommand
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#performPrivateCommand(java.lang.String, android.os.Bundle)}
 **/
InputConnection.prototype.performPrivateCommand = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'performPrivateCommand',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function deleteSurroundingTextInCodePoints
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#deleteSurroundingTextInCodePoints(int, int)}
 **/
InputConnection.prototype.deleteSurroundingTextInCodePoints = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'deleteSurroundingTextInCodePoints',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function deleteSurroundingText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#deleteSurroundingText(int, int)}
 **/
InputConnection.prototype.deleteSurroundingText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'deleteSurroundingText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function endBatchEdit
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#endBatchEdit()}
 **/
InputConnection.prototype.endBatchEdit = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'endBatchEdit',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function finishComposingText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#finishComposingText()}
 **/
InputConnection.prototype.finishComposingText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'finishComposingText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getTextBeforeCursor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#getTextBeforeCursor(int, int)}
 **/
InputConnection.prototype.getTextBeforeCursor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTextBeforeCursor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function commitCompletion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#commitCompletion(android.view.inputmethod.CompletionInfo)}
 **/
InputConnection.prototype.commitCompletion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'commitCompletion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function commitContent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#commitContent(android.view.inputmethod.InputContentInfo, int, android.os.Bundle)}
 **/
InputConnection.prototype.commitContent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'commitContent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function performEditorAction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#performEditorAction(int)}
 **/
InputConnection.prototype.performEditorAction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'performEditorAction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function reportFullscreenMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#reportFullscreenMode(boolean)}
 **/
InputConnection.prototype.reportFullscreenMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'reportFullscreenMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setComposingText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#setComposingText(java.lang.CharSequence, int)}
 **/
InputConnection.prototype.setComposingText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setComposingText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setComposingRegion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#setComposingRegion(int, int)}
 **/
InputConnection.prototype.setComposingRegion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setComposingRegion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function closeConnection
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#closeConnection()}
 **/
InputConnection.prototype.closeConnection = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'closeConnection',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setSelection
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#setSelection(int, int)}
 **/
InputConnection.prototype.setSelection = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSelection',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getExtractedText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#getExtractedText(android.view.inputmethod.ExtractedTextRequest, int)}
 **/
InputConnection.prototype.getExtractedText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getExtractedText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function commitText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#commitText(java.lang.CharSequence, int)}
 **/
InputConnection.prototype.commitText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'commitText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function requestCursorUpdates
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#requestCursorUpdates(int)}
 **/
InputConnection.prototype.requestCursorUpdates = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requestCursorUpdates',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function beginBatchEdit
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#beginBatchEdit()}
 **/
InputConnection.prototype.beginBatchEdit = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'beginBatchEdit',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getCursorCapsMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#getCursorCapsMode(int)}
 **/
InputConnection.prototype.getCursorCapsMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCursorCapsMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function sendKeyEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputConnection.html#sendKeyEvent(android.view.KeyEvent)}
 **/
InputConnection.prototype.sendKeyEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'sendKeyEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputConnection') {
			return new InputConnection(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

InputConnection.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

InputConnection.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = InputConnection;
